// #autoload
// #name = NotifyHud
// #description = Notifys you on kills, flag status, no ammo and repkit status.
// #version = 1.2
// #date = 14 March 2003
// #author = Danny de Groot
// #warrior = OddBall-
// #category = OddBall
// #email = dannydg1985@hotmail.com
// #web = http://www.oddballsplace.tk
// #include = support/player_support.cs
// #include = support/team_tracker.cs

new GuiControlProfile("NotifyHudText")
{
	fontType = "Arial";
	fontSize = 16;
	fontcolor = "0 222 219 255";
	justify = "center";
	fontColors[6] = $PlayerNameColor;
	fontColors[7] = $TribeTagColor;
	fontColors[8] = $SmurfNameColor;
	fontColors[9] = $BotNameColor;
};

if(!isObject(NotifyHud))
{
	new ScriptObject(NotifyHud)
	{
		class = NotifyHud;
	};
} 

package NotifyHud {

	function NotifyHud::Create(%this) {

		new ShellFieldCtrl(NotifyHudMain) {
			profile = "GuiConsoleProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "0 350";
			extent = "300 16";
			minExtent = "300 16";
			visible = "0";
			setFirstResponder = "0";

			new GuiMLTextCtrl(NotifyHudText) {
				profile = "NotifyHudText";
				horizSizing = "center";
				vertSizing = "center";
				position = "0 0";
				extent = "300 16";
				minExtent = "300 16";
				visible = "1";
				helpTag = "0";
				lineSpacing = "2";
				allowColorChars = "1";
				maxChars = "-1";
			};

		};

		PlayGui.add(NotifyHudMain);

	}

	function NotifyHud::setText(%this, %text) {
		NotifyHudText.setText("<just:center>" @ %text);
		NotifyHudMain.setVisible(true);
		if (%this.Schedule !$= "")
		{
			cancel(%this.Schedule);
			%this.Schedule = "";
		}
		%this.Schedule = schedule(3000, 0, eval, "NotifyHudMain.setVisible(false);");
	}

	function NotifyHud::CallBacks(%this) {
		// Kills
		addMessageCallBack('msgTeamKill', HandleKill);
		addMessageCallBack('MsgLegitKill', HandleKill);
		addMessageCallBack('MsgHeadshotKill', HandleKill);
		addMessageCallBack('msgExplosionKill', HandleKill);
		addMessageCallBack('msgVehicleKill', HandleKill);
		addMessageCallBack('msgTR2Knockdown', HandleKill);
		addMessageCallBack('MsgRearshotKill', HandleKill);
		addMessageCallBack('msgCTurretKill', HandleKill);
		// Rep Kit
		addMessageCallback('MsgItemPickup', HandleRepkitFound);
		addMessageCallback('MsgRepairKitUsed', HandleRepkitUse);
		// Flag
		addMessageCallback('MsgCTFFlagTaken', HandleCTFFlagTaken);
		addMessageCallback('MsgRabbitFlagTaken', HandleRabbitGrab);
		addMessageCallback('MsgTR2FlagTaken', HandleTR2FlagTaken);
	}

	function clientCmdSetAmmoHudCount(%amount) {
		parent::clientCmdSetAmmoHudCount(%amount);
		if (%amount == 0)
		{
			%text = "- no ammo -";
			NotifyHud.setText(%text);
		}
	}

	function HandleKill(%msgType, %msgString, %victimName, %vgen, %vposs, %killerName, %kgen, %kposs, %damageType) {
		%killer = detag(%killerName);
		%victim = detag(%victimName);
		%MySelf = PlayerList.getMyName();

		if ((%killer !$= "" && %victim !$= "") && (%killer $= %Myself || %victim $= %MySelf))
		{
			if (teamTracker.numTeams > 1)
			{
				%victimteamId = PlayerList.getTeamByName(%victim);
				%killerteamId = PlayerList.getTeamByName(%killer);

				if (%killerteamId == %victimteamId)
				{
					if (%killer $= %MySelf)
						%text = "You team killed: " @ %victim;
					else
						%text = "You were team killed by: " @ %killer;
				}
				else
				{
					if (%killer $= %MySelf)
						%text = "You killed: " @ %victim;
					else
						%text = "You were killed by: " @ %killer;
				}
			}
			else
			{
				if (%killer $= %MySelf)
					%text = "You killed: " @ %victim;
				else
					%text = "You were killed by: " @ %killer;
			}
			NotifyHud.setText(%text);
		}
	}

	function HandleCTFFlagTaken(%msgType, %msgString, %name, %teamName, %team, %nameBase) {
		%teamName = $clTeamScore[%team, 0];
		%MySelf = PlayerList.getMyName();
		%grabber = detag(%name);

		if (%grabber $= %MySelf)
			%text = "- you took the flag -";
		else
			%text = %grabber @ " took the " @ %teamName @ " flag";

		NotifyHud.setText(%text);
	}

	function HandleRabbitGrab(%msgType, %msgStr, %clientname, %teamname, %teamid, %rabbit) {
		%MySelf = PlayerList.getMyName();
		%rabbit = detag(%clientname);

		if (%rabbit $= %MySelf)
			%text = "- you took the flag -";
		else
			%text = %rabbit @ " took the flag";

		NotifyHud.setText(%text);
	}

	function HandleTR2FlagTaken(%msgType, %msgString, %name, %teamName, %team, %nameBase) {
		%MySelf = PlayerList.getMyName();
		%name = detag(%name);

		if (%name $= %MySelf)
			%text = "- you took the flag -";
		else
			%text = %name @ " took the flag";

		NotifyHud.setText(%text);
	}

	function HandleRepKitFound(%msgType, %msgString) {
		if (StrStr(%msgString, "You picked up a repair kit") != -1)
		{
			%text = "- repair kit found -";
			NotifyHud.setText(%text);
		}
	}

	function HandleRepkitUse(%msgType, %msgString) {
		if (StrStr(%msgString, "Repair Kit Used") != -1)
		{
			%text = "- repair kit used -";
			NotifyHud.setText(%text);
		}
	}

	function LoadingGui::onWake(%this) {
		parent::onWake(%this);
		if (!NotifyHud.AddedToHudMover)
		{
			if (isObject(HM) && isObject(HudMover))
				hudmover::addhud(NotifyHud, "NotifyHud");

			NotifyHud.AddedToHudMover = true;
		}
	}

	function DispatchLaunchMode() {
		parent::DispatchLaunchMode();
		NotifyHud.Create();
		NotifyHud.CallBacks();
	}

};
activatePackage(NotifyHud);
